# coding: utf-8

"""
    Payment Gateway API Specification.

    The documentation here is designed to provide all of the technical guidance required to consume and integrate with our APIs for payment processing. To learn more about our APIs please visit https://docs.firstdata.com/org/gateway.  # noqa: E501

    The version of the OpenAPI document: 21.5.0.20211029.001
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Basket(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'product_stock': 'str',
        'items': 'list[BasketItem]'
    }

    attribute_map = {
        'product_stock': 'productStock',
        'items': 'items'
    }

    def __init__(self, product_stock=None, items=None):  # noqa: E501
        """Basket - a model defined in OpenAPI"""  # noqa: E501

        self._product_stock = None
        self._items = None
        self.discriminator = None

        if product_stock is not None:
            self.product_stock = product_stock
        if items is not None:
            self.items = items

    @property
    def product_stock(self):
        """Gets the product_stock of this Basket.  # noqa: E501

        Product stock.  # noqa: E501

        :return: The product_stock of this Basket.  # noqa: E501
        :rtype: str
        """
        return self._product_stock

    @product_stock.setter
    def product_stock(self, product_stock):
        """Sets the product_stock of this Basket.

        Product stock.  # noqa: E501

        :param product_stock: The product_stock of this Basket.  # noqa: E501
        :type: str
        """
        allowed_values = ["check"]  # noqa: E501
        if product_stock not in allowed_values:
            raise ValueError(
                "Invalid value for `product_stock` ({0}), must be one of {1}"  # noqa: E501
                .format(product_stock, allowed_values)
            )

        self._product_stock = product_stock

    @property
    def items(self):
        """Gets the items of this Basket.  # noqa: E501

        The list of items included in the order.  # noqa: E501

        :return: The items of this Basket.  # noqa: E501
        :rtype: list[BasketItem]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this Basket.

        The list of items included in the order.  # noqa: E501

        :param items: The items of this Basket.  # noqa: E501
        :type: list[BasketItem]
        """

        self._items = items

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Basket):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
